Index: dll/ntdll/ldr/utils.c
===================================================================
--- dll/ntdll/ldr/utils.c	(revision 21808)
+++ dll/ntdll/ldr/utils.c	(working copy)
@@ -73,7 +73,7 @@
 LdrpLoadUserModuleSymbols(PLDR_DATA_TABLE_ENTRY LdrModule)
 {
   NtSystemDebugControl(
-    DebugDbgLoadSymbols,
+    SysDbgQueryVersion,
     (PVOID)LdrModule,
     0,
     NULL,
@@ -255,7 +255,7 @@
        Entry = ModuleListHead->Flink;
        while (Entry != ModuleListHead)
          {
-           Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+           Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
            if (Module->LoadCount == 0xFFFF &&
                Module->TlsIndex != 0xFFFF)
              {
@@ -498,7 +498,7 @@
 
   RtlEnterCriticalSection (NtCurrentPeb()->LoaderLock);
   InsertTailList(&NtCurrentPeb()->Ldr->InLoadOrderModuleList,
-                 &Module->InLoadOrderModuleList);
+                 &Module->InLoadOrderLinks);
   RtlLeaveCriticalSection(NtCurrentPeb()->LoaderLock);
 
   return(Module);
@@ -727,7 +727,7 @@
  */
 NTSTATUS NTAPI
 LdrLoadDll (IN PWSTR SearchPath OPTIONAL,
-            IN ULONG LoadFlags,
+            IN PULONG LoadFlags,
             IN PUNICODE_STRING Name,
             OUT PVOID *BaseAddress OPTIONAL)
 {
@@ -747,8 +747,8 @@
 
   *BaseAddress = NULL;
 
-  Status = LdrpLoadModule(SearchPath, LoadFlags, Name, &Module, BaseAddress);
-  if (NT_SUCCESS(Status) && 0 == (LoadFlags & LOAD_LIBRARY_AS_DATAFILE))
+  Status = LdrpLoadModule(SearchPath, *LoadFlags, Name, &Module, BaseAddress);
+  if (NT_SUCCESS(Status) && 0 == (*LoadFlags & LOAD_LIBRARY_AS_DATAFILE))
     {
       RtlEnterCriticalSection(NtCurrentPeb()->LoaderLock);
       Status = LdrpAttachProcess();
@@ -802,7 +802,7 @@
 
   while (Entry != ModuleListHead)
     {
-      ModulePtr = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+      ModulePtr = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
       DPRINT("Scanning %wZ at %p\n", &ModulePtr->BaseDllName, ModulePtr->DllBase);
 
@@ -901,7 +901,7 @@
     }
   while (Entry != ModuleListHead)
     {
-      ModulePtr = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+      ModulePtr = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
       DPRINT("Scanning %wZ %wZ\n", &ModulePtr->BaseDllName, &AdjustedName);
 
@@ -970,8 +970,9 @@
          */
         if (!NT_SUCCESS(Status))
           {
+             ULONG Flags = LDRP_PROCESS_CREATION_TIME;
              Status = LdrLoadDll(NULL,
-                                 LDRP_PROCESS_CREATION_TIME,
+                                 &Flags,
                                  &DllName,
                                  &BaseAddress);
              if (NT_SUCCESS(Status))
@@ -1289,7 +1290,7 @@
           ProtectPage2 = NULL;
         }
 
-      RelocationDir = LdrProcessRelocationBlock(Page,
+      RelocationDir = LdrProcessRelocationBlock((ULONG_PTR)Page,
                                                 Count,
                                                 TypeOffset,
                                                 Delta);
@@ -2269,7 +2270,7 @@
     Entry = ModuleListHead->Flink;
     while (Entry != ModuleListHead)
       {
-        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
         DPRINT("BaseDllName %wZ BaseAddress %p\n", &Module->BaseDllName, Module->DllBase);
 
@@ -2346,7 +2347,7 @@
     Entry = ModuleListHead->Flink;
     while (Entry != ModuleListHead)
     {
-        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
         if (Module->DllBase == BaseAddress)
         {
@@ -2385,7 +2386,7 @@
     Entry = ModuleListHead->Flink;
     while (Entry != ModuleListHead)
       {
-        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+        Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
         if ((ULONG_PTR)PcValue >= (ULONG_PTR)Module->DllBase &&
             (ULONG_PTR)PcValue < (ULONG_PTR)Module->DllBase + Module->SizeOfImage)
@@ -2520,7 +2521,7 @@
                ((UnloadAll && Module->LoadCount != 0xFFFF) || Module->LoadCount == 0))
              {
                /* remove the module entry from the list */
-               RemoveEntryList (&Module->InLoadOrderModuleList);
+               RemoveEntryList (&Module->InLoadOrderLinks);
                RemoveEntryList (&Module->InInitializationOrderModuleList);
 
                NtUnmapViewOfSection (NtCurrentProcess (), Module->DllBase);
@@ -2653,7 +2654,7 @@
         }
 
       Entry = NtCurrentPeb()->Ldr->InLoadOrderModuleList.Flink;
-      Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+      Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
       LdrpTlsCallback(Module, DLL_THREAD_ATTACH);
     }
 
@@ -2741,7 +2742,7 @@
   PCHAR p;
 
   DPRINT("LdrQueryProcessModuleInformation() called\n");
-
+ // FIXME: This code is ultra-duplicated. see lib\rtl\dbgbuffer.c
   RtlEnterCriticalSection (NtCurrentPeb()->LoaderLock);
 
   if (ModuleInformation == NULL || Size == 0)
@@ -2750,8 +2751,8 @@
     }
   else
     {
-      ModuleInformation->ModuleCount = 0;
-      ModulePtr = &ModuleInformation->ModuleEntry[0];
+      ModuleInformation->NumberOfModules = 0;
+      ModulePtr = &ModuleInformation->Modules[0];
       Status = STATUS_SUCCESS;
     }
 
@@ -2760,7 +2761,7 @@
 
   while (Entry != ModuleListHead)
     {
-      Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+      Module = CONTAINING_RECORD(Entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
       DPRINT("  Module %wZ\n",
              &Module->FullDllName);
@@ -2771,28 +2772,30 @@
         }
       else if (ModuleInformation != NULL)
         {
-          ModulePtr->Reserved[0] = ModulePtr->Reserved[1] = 0;      // FIXME: ??
-          ModulePtr->Base = Module->DllBase;
-          ModulePtr->Size = Module->SizeOfImage;
-          ModulePtr->Flags = Module->Flags;
-          ModulePtr->Index = 0;      // FIXME: index ??
-          ModulePtr->Unknown = 0;      // FIXME: ??
-          ModulePtr->LoadCount = Module->LoadCount;
+          ModulePtr->Section = 0;
+          ModulePtr->MappedBase = NULL;      // FIXME: ??
+          ModulePtr->ImageBase        = Module->DllBase;
+          ModulePtr->ImageSize        = Module->SizeOfImage;
+          ModulePtr->Flags       = Module->Flags;
+          ModulePtr->LoadOrderIndex       = 0;      // FIXME:  ??
+          ModulePtr->InitOrderIndex     = 0;      // FIXME: ??
+          ModulePtr->LoadCount   = Module->LoadCount;
 
-          AnsiString.Length = 0;
+          AnsiString.Length        = 0;
           AnsiString.MaximumLength = 256;
-          AnsiString.Buffer = ModulePtr->ImageName;
+          AnsiString.Buffer        = ModulePtr->FullPathName;
           RtlUnicodeStringToAnsiString(&AnsiString,
                                        &Module->FullDllName,
                                        FALSE);
-          p = strrchr(ModulePtr->ImageName, '\\');
+
+          p = strrchr(ModulePtr->FullPathName, '\\');
           if (p != NULL)
-            ModulePtr->ModuleNameOffset = p - ModulePtr->ImageName + 1;
+            ModulePtr->OffsetToFileName = p - ModulePtr->FullPathName + 1;
           else
-            ModulePtr->ModuleNameOffset = 0;
+            ModulePtr->OffsetToFileName = 0;
 
           ModulePtr++;
-          ModuleInformation->ModuleCount++;
+          ModuleInformation->NumberOfModules++;
         }
       UsedSize += sizeof(RTL_PROCESS_MODULE_INFORMATION);
 
@@ -3154,10 +3157,10 @@
 
 
 PIMAGE_BASE_RELOCATION NTAPI
-LdrProcessRelocationBlock(IN PVOID Address,
-			  IN USHORT Count,
+LdrProcessRelocationBlock(IN ULONG_PTR Address,
+			  IN ULONG Count,
 			  IN PUSHORT TypeOffset,
-			  IN ULONG_PTR Delta)
+			  IN LONG_PTR Delta)
 {
   SHORT Offset;
   USHORT Type;
Index: dll/ntdll/ldr/startup.c
===================================================================
--- dll/ntdll/ldr/startup.c	(revision 21808)
+++ dll/ntdll/ldr/startup.c	(working copy)
@@ -415,7 +415,7 @@
        NtModule->TimeDateStamp = NTHeaders->FileHeader.TimeDateStamp;
 
        InsertTailList(&Peb->Ldr->InLoadOrderModuleList,
-                      &NtModule->InLoadOrderModuleList);
+                      &NtModule->InLoadOrderLinks);
        InsertTailList(&Peb->Ldr->InInitializationOrderModuleList,
                       &NtModule->InInitializationOrderModuleList);
 
@@ -463,7 +463,7 @@
        ExeModule->TimeDateStamp = NTHeaders->FileHeader.TimeDateStamp;
 
        InsertHeadList(&Peb->Ldr->InLoadOrderModuleList,
-                      &ExeModule->InLoadOrderModuleList);
+                      &ExeModule->InLoadOrderLinks);
 
        LdrpInitLoader();
 
Index: dll/ntdll/ntdll.rbuild
===================================================================
--- dll/ntdll/ntdll.rbuild	(revision 21808)
+++ dll/ntdll/ntdll.rbuild	(working copy)
@@ -6,7 +6,7 @@
 	<define name="__NTDLL__" />
 	<define name="_DISABLE_TIDENTS" />
 	<define name="__USE_W32API" />
-	<define name="_WIN32_WINNT">0x0600</define>
+	<define name="_WIN32_WINNT">0x0502</define>
 	<define name="_NTOSKRNL_" />
 	<define name="__NO_CTYPE_INLINES" />
 	<library>rtl</library>
Index: dll/ntdll/def/ntdll.def
===================================================================
--- dll/ntdll/def/ntdll.def	(revision 21808)
+++ dll/ntdll/def/ntdll.def	(working copy)
@@ -522,8 +522,8 @@
 RtlIpv4StringToAddressExW@16
 RtlIpv4StringToAddressW@16
 RtlIpv6AddressToStringA@8
-RtlIpv6AddressToStringExA@16
-RtlIpv6AddressToStringExW@16
+RtlIpv6AddressToStringExA@20
+RtlIpv6AddressToStringExW@20
 RtlIpv6AddressToStringW@8
 RtlIpv6StringToAddressA@12
 RtlIpv6StringToAddressExA@16
Index: drivers/storage/diskdump/diskdump.c
===================================================================
--- drivers/storage/diskdump/diskdump.c	(revision 21808)
+++ drivers/storage/diskdump/diskdump.c	(working copy)
@@ -33,9 +33,8 @@
 #include <ntddscsi.h>
 #include <include/class2.h>
 #include <diskdump/diskdump.h>
-
-#include <ndk/extypes.h>
 #include <ndk/rtlfuncs.h>
+
 #include "../scsiport/scsiport_int.h"
 
 #define NDEBUG
Index: drivers/video/videoprt/videoprt.h
===================================================================
--- drivers/video/videoprt/videoprt.h	(revision 21808)
+++ drivers/video/videoprt/videoprt.h	(working copy)
@@ -41,6 +41,14 @@
 
 #define DPFLTR_IHVVIDEO_ID 0 /* FIXME */
 
+/* ROS Internal. Please deprecate */
+NTHALAPI
+VOID
+NTAPI
+HalReleaseDisplayOwnership(
+    VOID
+);
+
 typedef struct _VIDEO_PORT_ADDRESS_MAPPING
 {
    LIST_ENTRY List;
Index: drivers/video/videoprt/int10.c
===================================================================
--- drivers/video/videoprt/int10.c	(revision 21808)
+++ drivers/video/videoprt/int10.c	(working copy)
@@ -22,7 +22,7 @@
  */
 
 #include "videoprt.h"
-#include "internal/ke.h"
+#include "internal/i386/v86m.h"
 
 /* PRIVATE FUNCTIONS **********************************************************/
 
@@ -178,7 +178,7 @@
    Regs.Ds = BiosArguments->SegDs;
    DPRINT("- Input register SegEs: %x\n", BiosArguments->SegEs);
    Regs.Es = BiosArguments->SegEs;
-   Status = Ke386CallBios(0x10, &Regs);
+   Status = Ke386CallBios(0x10, (PCONTEXT)&Regs);
    BiosArguments->Eax = Regs.Eax;
    BiosArguments->Ebx = Regs.Ebx;
    BiosArguments->Ecx = Regs.Ecx;
@@ -234,7 +234,7 @@
    Regs.Edi = BiosArguments->Edi;
    DPRINT("- Input register Ebp: %x\n", BiosArguments->Ebp);
    Regs.Ebp = BiosArguments->Ebp;
-   Status = Ke386CallBios(0x10, &Regs);
+   Status = Ke386CallBios(0x10, (PCONTEXT)&Regs);
    BiosArguments->Eax = Regs.Eax;
    BiosArguments->Ebx = Regs.Ebx;
    BiosArguments->Ecx = Regs.Ecx;
Index: drivers/filesystems/ms/msfs.h
===================================================================
--- drivers/filesystems/ms/msfs.h	(revision 21808)
+++ drivers/filesystems/ms/msfs.h	(working copy)
@@ -2,7 +2,7 @@
 #define __SERVICES_FS_MS_MSFS_H
 
 #include <ntifs.h>
-#include <ndk/ntndk.h>
+#include <iotypes.h>
 
 /* 
  * FIXME: GCC doesn't have a working option for defaulting to a calling
Index: drivers/filesystems/vfat/vfat.h
===================================================================
--- drivers/filesystems/vfat/vfat.h	(revision 21808)
+++ drivers/filesystems/vfat/vfat.h	(working copy)
@@ -4,7 +4,6 @@
 #include <reactos/helper.h>
 
 #ifdef __GNUC__
-#include <ndk/ntndk.h>
 #include <ccros.h>
 
 #define USE_ROS_CC_AND_FS
Index: drivers/network/tcpip/include/precomp.h
===================================================================
--- drivers/network/tcpip/include/precomp.h	(revision 21808)
+++ drivers/network/tcpip/include/precomp.h	(working copy)
@@ -1,6 +1,7 @@
 #include <roscfg.h>
 #include <limits.h>
 #include <ntddk.h>
+#include <ntifs.h>
 #include <tdi.h>
 #include <tdistat.h>
 #include <../recmutex/recmutex.h>
@@ -37,5 +38,4 @@
 #include <interface.h>
 #include <ports.h>
 #include <ipifcons.h>
-#include <ndk/ntndk.h>
 #include <chew/chew.h>
Index: drivers/base/blue/blue.c
===================================================================
--- drivers/base/blue/blue.c	(revision 21808)
+++ drivers/base/blue/blue.c	(working copy)
@@ -18,11 +18,18 @@
 
 #include <wincon.h>
 #include <blue/ntddblue.h>
-#include <ndk/halfuncs.h>
 
 #define NDEBUG
 #include <debug.h>
 
+// ROS Internal. Please deprecate.
+NTHALAPI
+BOOLEAN
+NTAPI
+HalQueryDisplayOwnership(
+    VOID
+);
+
 /* DEFINITIONS ***************************************************************/
 
 #define VIDMEM_BASE        0xb8000
Index: drivers/multimedia/audio/sound/wave.c
===================================================================
--- drivers/multimedia/audio/sound/wave.c	(revision 21808)
+++ drivers/multimedia/audio/sound/wave.c	(working copy)
@@ -13,7 +13,6 @@
 /* FUNCTIONS **************************************************************/
 
 #include <ntddk.h>
-#include <halfuncs.h>
 #include <string.h>
 #include <devices.h>
 

